﻿package com.identityMine.manager
{
 import flash.display.MovieClip;
 
 import flash.utils.Timer;
 import flash.utils.getTimer;
 import flash.events.TimerEvent;
 import flash.events.Event;
 
 import com.identityMine.dna.DNA;
 
 public class MANAGER extends MovieClip
 {
	 
  private var local_MovementSequence : Array;
  private var local_DNA_array :Array;
  private var timesAlreadyRun = 0;
  private var timesToRun :int; 
  private var localeRows : int;
  private var localColumns : int;
    
  private var debug :Boolean = false;
  
  public function MANAGER(DNA_array :Array, MovementSequence : Array, Rows : int, Columns : int)
  {
	// Let's keep copies of these around...
	local_MovementSequence = MovementSequence;
	local_DNA_array = DNA_array;
	localeRows = Rows;
	localColumns = Columns;
	
  	//trace("Manager Initalized");
	//testRunOnce();
	var myTimer:Timer = new Timer(3000, local_MovementSequence.length); // 3 second
    myTimer.addEventListener(TimerEvent.TIMER, runOnce);
   myTimer.start();
  }
  
  private function testRunOnce():void
  {
    trace("MovementSequence[3] = " + local_MovementSequence[3] );
  }
  
  private function dtrace(input):void
  {
	  if (debug == true){
		trace(input); 
	  }
  
  }
  private function runOnce(event:TimerEvent):void 
  {

// Hard coded for this specific example	  

	  dtrace(timesAlreadyRun);
	  
	  var currentX:Number;
	  var oldX:Number;
	  var currentY:Number;
	  var oldY:Number;
	  
	  

	  /*
	  
	  trace(local_MovementSequence[timesAlreadyRun]);
	  */
	if ((timesAlreadyRun > 0) && (timesAlreadyRun < local_MovementSequence.length)){
		
	  currentX = local_MovementSequence[timesAlreadyRun][0];
	  oldX = local_MovementSequence[timesAlreadyRun-1][0];
	  
	  currentY = local_MovementSequence[timesAlreadyRun][1];
	  oldY = local_MovementSequence[timesAlreadyRun-1][1];
	  
		// X movement
		
		
		if (currentX != oldX){
			dtrace("x movement");
			
			// positive movement
			if (currentX > oldX){
				dtrace("   positive x movement");
				//trace(columns * currentY);
			}
			// negative movement
			else{
				dtrace("   negative x movement");
				trace(currentX * currentY);
			}
			
		}
		
		
		
		if (currentY != oldY){
			dtrace("y movement");
			
			if (currentY > oldY){
				dtrace("   positive y movement");
				trace(currentX * currentY + 4);
				//local_DNA_array[CurrentY] 
			}
			// negative movement
			else{
				dtrace("   negative y movement");
				trace(currentX * currentY);
			}
		}
		
		
	}
	
	 switch(timesAlreadyRun){
		case 1:
			
			//trace("   should be 6");
			local_DNA_array[6].CLEAVE();
			break;
		
		case 2:
			//trace("   should be 7");
			local_DNA_array[7].CLEAVE();
			break;
		
		case 3:
			//trace("   should be 12");
			local_DNA_array[12].CLEAVE();
			break;
		
		case 4:
			//trace("   should be 13")
			local_DNA_array[13].CLEAVE();
			break;
			
		case 5:
			// local_DNA_array[22].CLEAVE();
			 local_DNA_array[23].CLEAVE();
			break;
			
		case 6: 
			local_DNA_array[21].CLEAVE();
			break;
			
		case 7: 
			local_DNA_array[20].CLEAVE();
			break;
			
		case 8:
			local_DNA_array[15].CLEAVE();
		 	local_DNA_array[16].CLEAVE();
			break;
			
		case 9:
			local_DNA_array[11].CLEAVE();
			local_DNA_array[10].CLEAVE();
			break;
	
		default:
			break;
	  }
	
	
	//trace("runOnce() called @ " + getTimer() + " ms");
	timesAlreadyRun = timesAlreadyRun + 1;
	dtrace ("ENDING MOVEMENT SEQUENCE " + timesAlreadyRun);
  }
  
 }
 
}